Index: /code/branches/buildsystem2/src/tolua/lua/doit.lua
===================================================================
--- /code/branches/buildsystem2/src/tolua/lua/doit.lua	(revision 2519)
+++ /code/branches/buildsystem2/src/tolua/lua/doit.lua	(revision 2520)
@@ -46,5 +46,5 @@
     -- do this after setting the package name
     if flags.L then
-        if string.sub(flags.L, 1, 1) == '/' or string.sub(flags.L, 1, 1) == '\\' then
+        if string.sub(flags.L, 1, 1) == '/' or string.sub(flags.L, 1, 1) == '\\' or (string.len(flags.L) > 1 and string.sub(flags.L, 2, 2) == ':') then
             dofile(flags.L)
         else
@@ -63,5 +63,5 @@
     local file
     if flags.f then
-        if string.sub(flags.f, 1, 1) == '/' or string.sub(flags.f, 1, 1) == '\\' then
+        if string.sub(flags.f, 1, 1) == '/' or string.sub(flags.f, 1, 1) == '\\' or (string.len(flags.f) > 1 and string.sub(flags.f, 2, 2) == ':') then
             file = flags.f
         else
@@ -79,5 +79,5 @@
     if flags.o then
         local file
-        if string.sub(flags.o, 1, 1) == '/' or string.sub(flags.o, 1, 1) == '\\' then
+        if string.sub(flags.o, 1, 1) == '/' or string.sub(flags.o, 1, 1) == '\\' or (string.len(flags.o) > 1 and string.sub(flags.o, 2, 2) == ':') then
             file = flags.o
         else
@@ -110,5 +110,5 @@
         if flags.H then
             local file
-            if string.sub(flags.H, 1, 1) == '/' or string.sub(flags.H, 1, 1) == '\\' then
+            if string.sub(flags.H, 1, 1) == '/' or string.sub(flags.H, 1, 1) == '\\' or (string.len(flags.H) > 1 and string.sub(flags.H, 2, 2) == ':') then
                 file = flags.H
             else
Index: /code/branches/buildsystem2/src/tolua/lua/package.lua
===================================================================
--- /code/branches/buildsystem2/src/tolua/lua/package.lua	(revision 2519)
+++ /code/branches/buildsystem2/src/tolua/lua/package.lua	(revision 2520)
@@ -252,5 +252,5 @@
         local file
         if flags.f then
-            if string.sub(flags.f, 1, 1) == '/' or string.sub(flags.f, 1, 1) == '\\' then
+            if string.sub(flags.f, 1, 1) == '/' or string.sub(flags.f, 1, 1) == '\\' or (string.len(flags.f) > 1 and string.sub(flags.f, 2, 2) == ':') then
                 file = flags.f
             else
Index: /code/branches/buildsystem2/visual_studio/vc8/base.vsprops
===================================================================
--- /code/branches/buildsystem2/visual_studio/vc8/base.vsprops	(revision 2519)
+++ /code/branches/buildsystem2/visual_studio/vc8/base.vsprops	(revision 2520)
@@ -8,5 +8,5 @@
 	<Tool
 		Name="VCCLCompilerTool"
-		AdditionalIncludeDirectories="&quot;$(RootDir)src&quot;;&quot;$(RootDir)src\tolua&quot;;&quot;$(RootDir)src\ois&quot;;&quot;$(RootDir)src\orxonox&quot;;&quot;$(RootDir)src\ceguilua-0.6.1\ceguilua&quot;;&quot;$(LibDir)ogre-1.4.9\include&quot;;&quot;$(LibDir)boost-1.35.0\include&quot;;&quot;$(LibDir)cegui-0.6.1\include&quot;;&quot;$(LibDir)enet-1.2\include&quot;;&quot;$(LibDir)libogg-1.1.3\include&quot;;&quot;$(LibDir)libvorbis-1.2.0\include&quot;;&quot;$(LibDir)openal-1.1\include&quot;;&quot;$(LibDir)freealut-1.1.0\include&quot;;&quot;$(LibDir)tcl-8.5.2\include&quot;;&quot;$(LibDir)zlib-1.2.3\include&quot;;&quot;$(LibDir)lua-5.1.3\include&quot;"
+		AdditionalIncludeDirectories="&quot;$(RootDir)src&quot;;&quot;$(RootDir)\build\$(SolutionName)\$(ConfigurationName)&quot;;&quot;$(RootDir)src\tolua&quot;;&quot;$(RootDir)src\ois&quot;;&quot;$(RootDir)src\orxonox&quot;;&quot;$(RootDir)src\ceguilua-0.6.1\ceguilua&quot;;&quot;$(LibDir)ogre-1.4.9\include&quot;;&quot;$(LibDir)boost-1.35.0\include&quot;;&quot;$(LibDir)cegui-0.6.1\include&quot;;&quot;$(LibDir)enet-1.2\include&quot;;&quot;$(LibDir)libogg-1.1.3\include&quot;;&quot;$(LibDir)libvorbis-1.2.0\include&quot;;&quot;$(LibDir)openal-1.1\include&quot;;&quot;$(LibDir)freealut-1.1.0\include&quot;;&quot;$(LibDir)tcl-8.5.2\include&quot;;&quot;$(LibDir)zlib-1.2.3\include&quot;;&quot;$(LibDir)lua-5.1.3\include&quot;"
 		PreprocessorDefinitions="WIN32;__WIN32__;_WIN32;_WINDOWS;BOOST_ALL_DYN_LINK;OIS_DYNAMIC_LIB;ZLIB_WINAPI;LUA_BUILD_AS_DLL;TIXML_USE_TICPP;_CRT_SECURE_NO_WARNINGS"
 		WarningLevel="3"
Index: /code/branches/buildsystem2/visual_studio/vc8/core.vcproj
===================================================================
--- /code/branches/buildsystem2/visual_studio/vc8/core.vcproj	(revision 2519)
+++ /code/branches/buildsystem2/visual_studio/vc8/core.vcproj	(revision 2520)
@@ -161,7 +161,7 @@
 						Name="VCCustomBuildTool"
 						Description="Generating tolua bind files..."
-						CommandLine="path $(LibDir)\..\..\bin\$(SolutionName)\$(ConfigurationName); %path%&#x0D;&#x0A;cd $(RootDir)\bin&#x0D;&#x0A;echo $cfile &quot;CommandExecutor.h&quot; &gt; $(RootDir)\src\core\tolua.pkg&#x0D;&#x0A;echo $cfile &quot;LuaBind.h&quot; &gt;&gt; $(RootDir)\src\core\tolua.pkg&#x0D;&#x0A;$(OutDir)\toluaexe$(CS).exe -n Core -w $(RootDir)\src\core\ -s $(RootDir)\src\tolua\all-5.1.lua -o ToluaBindCore.cc -H ToluaBindCore.h tolua.pkg&#x0D;&#x0A;"
-						AdditionalDependencies="$(RootDir)\src\core\LuaBind.h;$(RootDir)\src\core\CommandExecutor.h"
-						Outputs="$(RootDir)\src\core\ToluaBindCore.cc; $(RootDir)\src\core\ToluaBindCore.h"
+						CommandLine="path $(LibDir)\..\..\bin\$(SolutionName)\$(ConfigurationName); %path%&#x0D;&#x0A;cd $(RootDir)\bin&#x0D;&#x0A;echo $cfile &quot;CommandExecutor.h&quot; &gt; $(IntDir)\tolua.pkg&#x0D;&#x0A;echo $cfile &quot;LuaBind.h&quot; &gt;&gt; $(IntDir)\tolua.pkg&#x0D;&#x0A;$(OutDir)\toluaexe$(CS).exe -n Core -w $(RootDir)\src\core\ -s $(RootDir)\src\tolua\all-5.1.lua -o $(IntDir)\ToluaBindCore.cc -H $(IntDir)\ToluaBindCore.h $(IntDir)\tolua.pkg&#x0D;&#x0A;"
+						AdditionalDependencies="$(RootDir)\src\core\LuaBind.h; $(RootDir)\src\core\CommandExecutor.h"
+						Outputs="$(IntDir)\ToluaBindCore.cc; $(IntDir)\ToluaBindCore.h; $(IntDir)\tolua.pkg"
 					/>
 				</FileConfiguration>
@@ -172,7 +172,7 @@
 						Name="VCCustomBuildTool"
 						Description="Generating tolua bind files..."
-						CommandLine="path $(LibDir)\..\..\bin\$(SolutionName)\$(ConfigurationName); %path%&#x0D;&#x0A;cd $(RootDir)\bin&#x0D;&#x0A;echo $cfile &quot;CommandExecutor.h&quot; &gt; $(RootDir)\src\core\tolua.pkg&#x0D;&#x0A;echo $cfile &quot;LuaBind.h&quot; &gt;&gt; $(RootDir)\src\core\tolua.pkg&#x0D;&#x0A;$(OutDir)\toluaexe$(CS).exe -n Core -w $(RootDir)\src\core\ -s $(RootDir)\src\tolua\all-5.1.lua -o ToluaBindCore.cc -H ToluaBindCore.h tolua.pkg&#x0D;&#x0A;"
-						AdditionalDependencies="$(RootDir)\src\core\LuaBind.h;$(RootDir)\src\core\CommandExecutor.h"
-						Outputs="$(RootDir)\src\core\ToluaBindCore.cc; $(RootDir)\src\core\ToluaBindCore.h"
+						CommandLine="path $(LibDir)\..\..\bin\$(SolutionName)\$(ConfigurationName); %path%&#x0D;&#x0A;cd $(RootDir)\bin&#x0D;&#x0A;echo $cfile &quot;CommandExecutor.h&quot; &gt; $(IntDir)\tolua.pkg&#x0D;&#x0A;echo $cfile &quot;LuaBind.h&quot; &gt;&gt; $(IntDir)\tolua.pkg&#x0D;&#x0A;$(OutDir)\toluaexe$(CS).exe -n Core -w $(RootDir)\src\core\ -s $(RootDir)\src\tolua\all-5.1.lua -o $(IntDir)\ToluaBindCore.cc -H $(IntDir)\ToluaBindCore.h $(IntDir)\tolua.pkg&#x0D;&#x0A;"
+						AdditionalDependencies="$(RootDir)\src\core\LuaBind.h; $(RootDir)\src\core\CommandExecutor.h"
+						Outputs="$(IntDir)\ToluaBindCore.cc; $(IntDir)\ToluaBindCore.h; $(IntDir)\tolua.pkg"
 					/>
 				</FileConfiguration>
@@ -219,9 +219,9 @@
 			</File>
 			<File
+				RelativePath="$(IntDir)\ToluaBindCore.cc"
+				>
+			</File>
+			<File
 				RelativePath="..\..\src\core\XMLNameListener.cc"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\core\ToluaBindCore.cc"
 				>
 			</File>
@@ -445,5 +445,5 @@
 			</File>
 			<File
-				RelativePath="..\..\src\core\ToluaBindCore.h"
+				RelativePath="$(IntDir)\ToluaBindCore.h"
 				>
 			</File>
Index: /code/branches/buildsystem2/visual_studio/vc8/orxonox.vcproj
===================================================================
--- /code/branches/buildsystem2/visual_studio/vc8/orxonox.vcproj	(revision 2519)
+++ /code/branches/buildsystem2/visual_studio/vc8/orxonox.vcproj	(revision 2520)
@@ -167,7 +167,7 @@
 						Name="VCCustomBuildTool"
 						Description="Generating tolua bind files..."
-						CommandLine="path $(LibDir)\..\..\bin\$(SolutionName)\$(ConfigurationName); %path%&#x0D;&#x0A;cd $(RootDir)\bin&#x0D;&#x0A;echo $cfile &quot;gui/GUIManager.h&quot; &gt; $(RootDir)\src\orxonox\tolua.pkg&#x0D;&#x0A;&quot;$(OutDir)\toluaexe$(CS).exe&quot; -n Orxonox -w $(RootDir)\src\orxonox\ -s $(RootDir)\src\tolua\all-5.1.lua -o ToluaBindOrxonox.cc -H ToluaBindOrxonox.h tolua.pkg&#x0D;&#x0A;"
+						CommandLine="path $(LibDir)\..\..\bin\$(SolutionName)\$(ConfigurationName); %path%&#x0D;&#x0A;cd $(RootDir)\bin&#x0D;&#x0A;echo $cfile &quot;gui/GUIManager.h&quot; &gt; $(IntDir)\tolua.pkg&#x0D;&#x0A;&quot;$(OutDir)\toluaexe$(CS).exe&quot; -n Orxonox -w $(RootDir)\src\orxonox\ -s $(RootDir)\src\tolua\all-5.1.lua -o $(IntDir)\ToluaBindOrxonox.cc -H $(IntDir)\ToluaBindOrxonox.h $(IntDir)\tolua.pkg&#x0D;&#x0A;"
 						AdditionalDependencies="$(RootDir)\src\orxonox\gui\GUIManager.h"
-						Outputs="$(RootDir)\src\orxonox\ToluaBindOrxonox.cc; $(RootDir)\src\orxonox\ToluaBindOrxonox.h"
+						Outputs="$(IntDir)\ToluaBindOrxonox.cc; $(IntDir)\ToluaBindOrxonox.h; $(IntDir)\tolua.pkg"
 					/>
 				</FileConfiguration>
@@ -178,7 +178,7 @@
 						Name="VCCustomBuildTool"
 						Description="Generating tolua bind files..."
-						CommandLine="path $(LibDir)\..\..\bin\$(SolutionName)\$(ConfigurationName); %path%&#x0D;&#x0A;cd $(RootDir)\bin&#x0D;&#x0A;echo $cfile &quot;gui/GUIManager.h&quot; &gt; $(RootDir)\src\orxonox\tolua.pkg&#x0D;&#x0A;&quot;$(OutDir)\toluaexe$(CS).exe&quot; -n Orxonox -w $(RootDir)\src\orxonox\ -s $(RootDir)\src\tolua\all-5.1.lua -o ToluaBindOrxonox.cc -H ToluaBindOrxonox.h tolua.pkg&#x0D;&#x0A;"
+						CommandLine="path $(LibDir)\..\..\bin\$(SolutionName)\$(ConfigurationName); %path%&#x0D;&#x0A;cd $(RootDir)\bin&#x0D;&#x0A;echo $cfile &quot;gui/GUIManager.h&quot; &gt; $(IntDir)\tolua.pkg&#x0D;&#x0A;&quot;$(OutDir)\toluaexe$(CS).exe&quot; -n Orxonox -w $(RootDir)\src\orxonox\ -s $(RootDir)\src\tolua\all-5.1.lua -o $(IntDir)\ToluaBindOrxonox.cc -H $(IntDir)\ToluaBindOrxonox.h $(IntDir)\tolua.pkg&#x0D;&#x0A;"
 						AdditionalDependencies="$(RootDir)\src\orxonox\gui\GUIManager.h"
-						Outputs="$(RootDir)\src\orxonox\ToluaBindOrxonox.cc; $(RootDir)\src\orxonox\ToluaBindOrxonox.h"
+						Outputs="$(IntDir)\ToluaBindOrxonox.cc; $(IntDir)\ToluaBindOrxonox.h; $(IntDir)\tolua.pkg"
 					/>
 				</FileConfiguration>
@@ -225,5 +225,5 @@
 			</File>
 			<File
-				RelativePath="..\..\src\orxonox\ToluaBindOrxonox.cc"
+				RelativePath="$(IntDir)\ToluaBindOrxonox.cc"
 				>
 				<FileConfiguration
@@ -847,5 +847,5 @@
 			</File>
 			<File
-				RelativePath="..\..\src\orxonox\ToluaBindOrxonox.h"
+				RelativePath="$(IntDir)\ToluaBindOrxonox.h"
 				>
 			</File>
Index: /code/branches/buildsystem2/visual_studio/vc8/orxonox_vc8.sln
===================================================================
--- /code/branches/buildsystem2/visual_studio/vc8/orxonox_vc8.sln	(revision 2519)
+++ /code/branches/buildsystem2/visual_studio/vc8/orxonox_vc8.sln	(revision 2520)
@@ -25,10 +25,4 @@
 	EndProjectSection
 EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "audio", "audio.vcproj", "{4733BD1A-E04C-458D-8BFB-5010250EA497}"
-	ProjectSection(ProjectDependencies) = postProject
-		{271715F3-5B90-4110-A552-70C788084A86} = {271715F3-5B90-4110-A552-70C788084A86}
-		{2240ECD7-2F48-4431-8E1B-25466A384CCC} = {2240ECD7-2F48-4431-8E1B-25466A384CCC}
-	EndProjectSection
-EndProject
 Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "network", "network.vcproj", "{35575B59-E1AE-40E8-89C4-2862B5B09B68}"
 	ProjectSection(ProjectDependencies) = postProject
@@ -45,5 +39,4 @@
 		{4BBBB49F-3203-4BB4-AAE3-48BCA96FCB4F} = {4BBBB49F-3203-4BB4-AAE3-48BCA96FCB4F}
 		{35575B59-E1AE-40E8-89C4-2862B5B09B68} = {35575B59-E1AE-40E8-89C4-2862B5B09B68}
-		{4733BD1A-E04C-458D-8BFB-5010250EA497} = {4733BD1A-E04C-458D-8BFB-5010250EA497}
 		{A0724246-CB7C-420B-BCF0-68EF205AFE34} = {A0724246-CB7C-420B-BCF0-68EF205AFE34}
 		{35E36A06-0A5C-4A0D-9AB6-5A05EAA87626} = {35E36A06-0A5C-4A0D-9AB6-5A05EAA87626}
@@ -89,8 +82,4 @@
 		{271715F3-5B90-4110-A552-70C788084A86}.Release|Win32.ActiveCfg = Release|Win32
 		{271715F3-5B90-4110-A552-70C788084A86}.Release|Win32.Build.0 = Release|Win32
-		{4733BD1A-E04C-458D-8BFB-5010250EA497}.Debug|Win32.ActiveCfg = Debug|Win32
-		{4733BD1A-E04C-458D-8BFB-5010250EA497}.Debug|Win32.Build.0 = Debug|Win32
-		{4733BD1A-E04C-458D-8BFB-5010250EA497}.Release|Win32.ActiveCfg = Release|Win32
-		{4733BD1A-E04C-458D-8BFB-5010250EA497}.Release|Win32.Build.0 = Release|Win32
 		{35575B59-E1AE-40E8-89C4-2862B5B09B68}.Debug|Win32.ActiveCfg = Debug|Win32
 		{35575B59-E1AE-40E8-89C4-2862B5B09B68}.Debug|Win32.Build.0 = Debug|Win32