Index: code/branches/buildsystem2/TODO_buildsystem
===================================================================
--- code/branches/buildsystem2/TODO_buildsystem	(revision 2533)
+++ 	(revision )
@@ -1,1 +1,0 @@
-- Detect ceguilua version other than with the variable from the pkg config file. It might not exist everywhere.
Index: code/branches/buildsystem2/src/orxonox/gamestates/GSGraphics.cc
===================================================================
--- code/branches/buildsystem2/src/orxonox/gamestates/GSGraphics.cc	(revision 2533)
+++ code/branches/buildsystem2/src/orxonox/gamestates/GSGraphics.cc	(revision 2534)
@@ -31,4 +31,6 @@
 
 #include <fstream>
+#include <boost/filesystem.hpp>
+
 #include <OgreConfigFile.h>
 #include <OgreFrameListener.h>
@@ -371,14 +373,9 @@
             ogrePluginsFolder_ = ".";
 
-#if ORXONOX_PLATFORM == ORXONOX_PLATFORM_WIN32
-        convertToWindowsPath(&ogrePluginsFolder_);
-#else
-        convertToUnixPath(&ogrePluginsFolder_);
-#endif
-
+        boost::filesystem::path folder(ogrePluginsFolder_);
         // Do some SubString magic to get the comma separated list of plugins
         SubString plugins(ogrePlugins_, ",", " ", false, 92, false, 34, false, 40, 41, false, '\0');
         for (unsigned int i = 0; i < plugins.size(); ++i)
-            ogreRoot_->loadPlugin(ogrePluginsFolder_ + plugins[i]);
+            ogreRoot_->loadPlugin((folder / plugins[i]).native_file_string());
     }
 
Index: code/branches/buildsystem2/src/util/String.cc
===================================================================
--- code/branches/buildsystem2/src/util/String.cc	(revision 2533)
+++ code/branches/buildsystem2/src/util/String.cc	(revision 2534)
@@ -493,38 +493,2 @@
     }
 }
-
-/**
-    @brief Converts a path string to windows with "\" instead of "/".
-    @param str String pointer to be manipulated
-*/
-void convertToWindowsPath(std::string* str)
-{
-    std::string& path = *str;
-    // replace all occurences of "/" with "\"
-    for (unsigned int i = 0; i < path.length(); ++i)
-    {
-        if (path[i] == '/')
-            path[i] = '\\';
-    }
-    // add an extra '\\' at the end to make it a complete path
-    if (path != "" && path[path.length() - 1] != '\\')
-        path.append("\\");
-}
-
-/**
-    @brief Converts a path string to unix with "/" instead of "\".
-    @param str String pointer to be manipulated
-*/
-void convertToUnixPath(std::string* str)
-{
-    std::string& path = *str;
-    // replace all occurences of "\" with "/"
-    for (unsigned int i = 0; i < path.length(); ++i)
-    {
-        if (path[i] == '\\')
-            path[i] = '/';
-    }
-    // add an extra '\\' at the end to make it a complete path
-    if (path != "" && path[path.length() - 1] != '/')
-        path.append("/");
-}
Index: code/branches/buildsystem2/src/util/String.h
===================================================================
--- code/branches/buildsystem2/src/util/String.h	(revision 2533)
+++ code/branches/buildsystem2/src/util/String.h	(revision 2534)
@@ -81,6 +81,3 @@
 }
 
-_UtilExport void         convertToWindowsPath(std::string* str);
-_UtilExport void         convertToUnixPath(std::string* str);
-
 #endif /* _Util_String_H__ */
Index: code/branches/buildsystem2/visual_studio/vc8/core.vcproj
===================================================================
--- code/branches/buildsystem2/visual_studio/vc8/core.vcproj	(revision 2533)
+++ code/branches/buildsystem2/visual_studio/vc8/core.vcproj	(revision 2534)
@@ -441,8 +441,4 @@
 			</File>
 			<File
-				RelativePath="..\..\src\core\tolua_bind.h"
-				>
-			</File>
-			<File
 				RelativePath="$(IntDir)\ToluaBindCore.h"
 				>
Index: code/branches/buildsystem2/visual_studio/vc8/orxonox.vcproj
===================================================================
--- code/branches/buildsystem2/visual_studio/vc8/orxonox.vcproj	(revision 2533)
+++ code/branches/buildsystem2/visual_studio/vc8/orxonox.vcproj	(revision 2534)
@@ -843,8 +843,4 @@
 			</File>
 			<File
-				RelativePath="..\..\src\orxonox\tolua_bind.h"
-				>
-			</File>
-			<File
 				RelativePath="$(IntDir)\ToluaBindOrxonox.h"
 				>