Index: /code/branches/presentation/src/orxonox/objects/Scene.cc
===================================================================
--- /code/branches/presentation/src/orxonox/objects/Scene.cc	(revision 2536)
+++ /code/branches/presentation/src/orxonox/objects/Scene.cc	(revision 2537)
@@ -73,7 +73,6 @@
         {
             // create a dummy SceneManager of our own since we don't have Ogre::Root.
-            this->sceneManagerDedicated_ = new Ogre::DefaultSceneManager("");
-            this->rootSceneNode_ = this->sceneManagerDedicated_->getRootSceneNode();
-            this->sceneManager_ = 0;
+            this->sceneManager_ = new Ogre::DefaultSceneManager("");
+            this->rootSceneNode_ = this->sceneManager_->getRootSceneNode();
         }
 
@@ -102,5 +101,5 @@
             else if (!Core::showsGraphics())
             {
-                delete this->sceneManagerDedicated_;
+                delete this->sceneManager_;
             }
 
Index: /code/branches/presentation/src/orxonox/objects/Scene.h
===================================================================
--- /code/branches/presentation/src/orxonox/objects/Scene.h	(revision 2536)
+++ /code/branches/presentation/src/orxonox/objects/Scene.h	(revision 2537)
@@ -80,5 +80,4 @@
 
             Ogre::SceneManager*      sceneManager_;
-            Ogre::SceneManager*      sceneManagerDedicated_;
             Ogre::SceneNode*         rootSceneNode_;
 
Index: /code/branches/presentation/src/orxonox/objects/worldentities/Backlight.cc
===================================================================
--- /code/branches/presentation/src/orxonox/objects/worldentities/Backlight.cc	(revision 2536)
+++ /code/branches/presentation/src/orxonox/objects/worldentities/Backlight.cc	(revision 2537)
@@ -214,5 +214,5 @@
                 this->update_trailmaterial();
                 if (this->ribbonTrail_)
-                    this->ribbonTrail_->addNode(const_cast<Ogre::SceneNode*>(this->getNode()));
+                    this->ribbonTrail_->addNode(this->node_);
             }
         }
Index: /code/branches/presentation/src/orxonox/objects/worldentities/Billboard.cc
===================================================================
--- /code/branches/presentation/src/orxonox/objects/worldentities/Billboard.cc	(revision 2536)
+++ /code/branches/presentation/src/orxonox/objects/worldentities/Billboard.cc	(revision 2537)
@@ -34,4 +34,5 @@
 #include "core/CoreIncludes.h"
 #include "core/XMLPort.h"
+#include "core/Core.h"
 #include "objects/Scene.h"
 
@@ -80,5 +81,5 @@
         if (!this->billboard_.getBillboardSet())
         {
-            if (this->getScene() && this->getScene()->getSceneManager())
+            if (this->getScene() && Core::showsGraphics())
             {
                 this->billboard_.setBillboardSet(this->getScene()->getSceneManager(), this->material_, this->colour_, 1);
@@ -97,5 +98,5 @@
         {
 /*
-            if (this->getScene() && this->getScene()->getSceneManager() && (this->material_ != ""))
+            if (this->getScene() && Core::showsGraphics() && (this->material_ != ""))
             {
                 this->billboard_.setBillboardSet(this->getScene()->getSceneManager(), this->material_, this->colour_, 1);
Index: /code/branches/presentation/src/orxonox/objects/worldentities/ExplosionChunk.cc
===================================================================
--- /code/branches/presentation/src/orxonox/objects/worldentities/ExplosionChunk.cc	(revision 2536)
+++ /code/branches/presentation/src/orxonox/objects/worldentities/ExplosionChunk.cc	(revision 2537)
@@ -47,5 +47,5 @@
         RegisterObject(ExplosionChunk);
 
-        if (!this->getScene() || !this->getScene()->getSceneManager())
+        if (!this->getScene() || !Core::showsGraphics() || !this->getScene()->getSceneManager())
             ThrowException(AbortLoading, "Can't create ExplosionChunk, no scene or no scene manager given.");
 
Index: /code/branches/presentation/src/orxonox/objects/worldentities/ParticleEmitter.cc
===================================================================
--- /code/branches/presentation/src/orxonox/objects/worldentities/ParticleEmitter.cc	(revision 2536)
+++ /code/branches/presentation/src/orxonox/objects/worldentities/ParticleEmitter.cc	(revision 2537)
@@ -107,5 +107,5 @@
         }
 
-        if (this->getScene() && this->getScene()->getSceneManager())
+        if (Core::showsGraphics() && this->getScene() && this->getScene()->getSceneManager())
         {
             try
Index: /code/branches/presentation/src/orxonox/objects/worldentities/triggers/Trigger.cc
===================================================================
--- /code/branches/presentation/src/orxonox/objects/worldentities/triggers/Trigger.cc	(revision 2536)
+++ /code/branches/presentation/src/orxonox/objects/worldentities/triggers/Trigger.cc	(revision 2537)
@@ -36,4 +36,5 @@
 #include "core/ConsoleCommand.h"
 #include "core/XMLPort.h"
+#include "core/Core.h"
 #include "objects/Scene.h"
 
@@ -66,5 +67,5 @@
 //    this->bUpdating_ = false;
 
-    if (this->getScene() && this->getScene()->getSceneManager())
+    if (this->getScene() && Core::showsGraphics())
     {
       this->debugBillboard_.setBillboardSet(this->getScene()->getSceneManager(), "Examples/Flare", ColourValue(1.0, 0.0, 0.0), 1);