Index: code/branches/presentation/visual_studio/vc8/core.vcproj
===================================================================
--- code/branches/presentation/visual_studio/vc8/core.vcproj	(revision 2503)
+++ code/branches/presentation/visual_studio/vc8/core.vcproj	(revision 2538)
@@ -153,4 +153,8 @@
 			</File>
 			<File
+				RelativePath="..\..\src\core\CommandLine.cc"
+				>
+			</File>
+			<File
 				RelativePath="..\..\src\core\ConfigFileManager.cc"
 				>
@@ -169,4 +173,8 @@
 			</File>
 			<File
+				RelativePath="..\..\src\core\Executor.cc"
+				>
+			</File>
+			<File
 				RelativePath="..\..\src\core\GameState.cc"
 				>
@@ -181,17 +189,5 @@
 			</File>
 			<File
-				RelativePath="..\..\src\core\OrxonoxClass.cc"
-				>
-			</File>
-			<File
 				RelativePath="..\..\src\core\RootGameState.cc"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\core\Template.cc"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\core\XMLNameListener.cc"
 				>
 			</File>
@@ -231,5 +227,5 @@
 			</Filter>
 			<Filter
-				Name="command"
+				Name="commands"
 				>
 				<File
@@ -246,8 +242,4 @@
 				</File>
 				<File
-					RelativePath="..\..\src\core\CommandLine.cc"
-					>
-				</File>
-				<File
 					RelativePath="..\..\src\core\ConsoleCommand.cc"
 					>
@@ -257,8 +249,4 @@
 					>
 				</File>
-				<File
-					RelativePath="..\..\src\core\Executor.cc"
-					>
-				</File>
 			</Filter>
 			<Filter
@@ -266,4 +254,8 @@
 				>
 				<File
+					RelativePath="..\..\src\core\BaseObject.cc"
+					>
+				</File>
+				<File
 					RelativePath="..\..\src\core\Factory.cc"
 					>
@@ -281,12 +273,12 @@
 					>
 				</File>
-			</Filter>
-			<Filter
-				Name="level"
-				>
-				<File
-					RelativePath="..\..\src\core\BaseObject.cc"
-					>
-				</File>
+				<File
+					RelativePath="..\..\src\core\OrxonoxClass.cc"
+					>
+				</File>
+			</Filter>
+			<Filter
+				Name="loading"
+				>
 				<File
 					RelativePath="..\..\src\core\ClassTreeMask.cc"
@@ -303,4 +295,12 @@
 				<File
 					RelativePath="..\..\src\core\NamespaceNode.cc"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\core\Template.cc"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\core\XMLNameListener.cc"
 					>
 				</File>
@@ -389,4 +389,8 @@
 			</File>
 			<File
+				RelativePath="..\..\src\core\CommandLine.h"
+				>
+			</File>
+			<File
 				RelativePath="..\..\src\core\ConfigFileManager.h"
 				>
@@ -417,4 +421,12 @@
 			</File>
 			<File
+				RelativePath="..\..\src\core\Executor.h"
+				>
+			</File>
+			<File
+				RelativePath="..\..\src\core\Functor.h"
+				>
+			</File>
+			<File
 				RelativePath="..\..\src\core\GameState.h"
 				>
@@ -429,8 +441,4 @@
 			</File>
 			<File
-				RelativePath="..\..\src\core\OrxonoxClass.h"
-				>
-			</File>
-			<File
 				RelativePath="..\..\src\core\RootGameState.h"
 				>
@@ -440,16 +448,4 @@
 				>
 			</File>
-			<File
-				RelativePath="..\..\src\core\Template.h"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\core\XMLIncludes.h"
-				>
-			</File>
-			<File
-				RelativePath="..\..\src\core\XMLNameListener.h"
-				>
-			</File>
 			<Filter
 				Name="input"
@@ -509,5 +505,5 @@
 			</Filter>
 			<Filter
-				Name="command"
+				Name="commands"
 				>
 				<File
@@ -532,8 +528,4 @@
 				</File>
 				<File
-					RelativePath="..\..\src\core\CommandLine.h"
-					>
-				</File>
-				<File
 					RelativePath="..\..\src\core\ConsoleCommand.h"
 					>
@@ -543,12 +535,4 @@
 					>
 				</File>
-				<File
-					RelativePath="..\..\src\core\Executor.h"
-					>
-				</File>
-				<File
-					RelativePath="..\..\src\core\Functor.h"
-					>
-				</File>
 			</Filter>
 			<Filter
@@ -576,4 +560,8 @@
 				>
 				<File
+					RelativePath="..\..\src\core\BaseObject.h"
+					>
+				</File>
+				<File
 					RelativePath="..\..\src\core\ClassFactory.h"
 					>
@@ -611,12 +599,12 @@
 					>
 				</File>
-			</Filter>
-			<Filter
-				Name="level"
-				>
-				<File
-					RelativePath="..\..\src\core\BaseObject.h"
-					>
-				</File>
+				<File
+					RelativePath="..\..\src\core\OrxonoxClass.h"
+					>
+				</File>
+			</Filter>
+			<Filter
+				Name="loading"
+				>
 				<File
 					RelativePath="..\..\src\core\ClassTreeMask.h"
@@ -636,5 +624,17 @@
 				</File>
 				<File
+					RelativePath="..\..\src\core\Template.h"
+					>
+				</File>
+				<File
 					RelativePath="..\..\src\core\XMLFile.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\core\XMLIncludes.h"
+					>
+				</File>
+				<File
+					RelativePath="..\..\src\core\XMLNameListener.h"
 					>
 				</File>
Index: code/branches/presentation/visual_studio/vc8/orxonox.vcproj
===================================================================
--- code/branches/presentation/visual_studio/vc8/orxonox.vcproj	(revision 2503)
+++ code/branches/presentation/visual_studio/vc8/orxonox.vcproj	(revision 2538)
@@ -450,18 +450,4 @@
 							RelativePath="..\..\src\orxonox\objects\weaponSystem\munitions\LaserGunMunition.cc"
 							>
-							<FileConfiguration
-								Name="Debug|Win32"
-								>
-								<Tool
-									Name="VCCLCompilerTool"
-								/>
-							</FileConfiguration>
-							<FileConfiguration
-								Name="Release|Win32"
-								>
-								<Tool
-									Name="VCCLCompilerTool"
-								/>
-							</FileConfiguration>
 						</File>
 					</Filter>
@@ -472,18 +458,4 @@
 							RelativePath="..\..\src\orxonox\objects\weaponSystem\weapons\LaserGun.cc"
 							>
-							<FileConfiguration
-								Name="Debug|Win32"
-								>
-								<Tool
-									Name="VCCLCompilerTool"
-								/>
-							</FileConfiguration>
-							<FileConfiguration
-								Name="Release|Win32"
-								>
-								<Tool
-									Name="VCCLCompilerTool"
-								/>
-							</FileConfiguration>
 						</File>
 						<File
@@ -514,54 +486,12 @@
 							RelativePath="..\..\src\orxonox\objects\weaponSystem\projectiles\BillboardProjectile.cc"
 							>
-							<FileConfiguration
-								Name="Debug|Win32"
-								>
-								<Tool
-									Name="VCCLCompilerTool"
-								/>
-							</FileConfiguration>
-							<FileConfiguration
-								Name="Release|Win32"
-								>
-								<Tool
-									Name="VCCLCompilerTool"
-								/>
-							</FileConfiguration>
 						</File>
 						<File
 							RelativePath="..\..\src\orxonox\objects\weaponSystem\projectiles\ParticleProjectile.cc"
 							>
-							<FileConfiguration
-								Name="Debug|Win32"
-								>
-								<Tool
-									Name="VCCLCompilerTool"
-								/>
-							</FileConfiguration>
-							<FileConfiguration
-								Name="Release|Win32"
-								>
-								<Tool
-									Name="VCCLCompilerTool"
-								/>
-							</FileConfiguration>
 						</File>
 						<File
 							RelativePath="..\..\src\orxonox\objects\weaponSystem\projectiles\Projectile.cc"
 							>
-							<FileConfiguration
-								Name="Debug|Win32"
-								>
-								<Tool
-									Name="VCCLCompilerTool"
-								/>
-							</FileConfiguration>
-							<FileConfiguration
-								Name="Release|Win32"
-								>
-								<Tool
-									Name="VCCLCompilerTool"
-								/>
-							</FileConfiguration>
 						</File>
 					</Filter>